//+------------------------------------------------------------------+
//|                                                  _LUKA.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+----------------------------------------------------------------------------+

extern string _P1="-   -";
extern bool   ReverseSignal    = False;   // True -   
extern bool   ClosePosifChange = False;   //     
extern bool   OpenBuy          = True;    //   Buy
extern bool   OpenSell         = True;    //   Sell
extern int    MaxOrdersCount   = 2;       //   - , -1  
extern int    MaxBuyCount      = 1;       //  - Buy , -1  
extern int    MaxSellCount     = 1;       //  - Sell , -1  
extern double Ficsir_Lot       = 0.01;    //   
       double Lot              = 0.01;    //   
       double Min_lot          = 0.01;    //    
       double Max_lot          = 100.0;   //    
extern bool   Dynamic_Lot      = True;    //     % 
extern double Risk             = 0.5;     //   %     
extern double TakeProfit       = 150.0;   // TakeProfit,  0  
extern double StopLoss         = 50.0;    // StopLoss,  0  
extern int    Magic            = 12345;   //   
       bool   Log              = True;    //  
//+----------------------------------------------------------------------------+
                                      
       string _P2="-   -";
       double iac_dist       = 0.0;     // AC
       double imacd_dist     = 0.00065; // MACD
//+----------------------------------------------------------------------------+

extern string _P3="-   -";
extern int    LP               = 0;       //  ,  0  
extern int    LP_Step          = 0;       //  ,  0  
//+----------------------------------------------------------------------------+

extern string _P4="-   -";
extern bool   On_Off_TR        = True;    // ,   
extern int    TS_Buy           = 30;      //     Buy
extern int    TS_Sell          = 30;      //     Sell
extern int    TS_StepBuy       = 3;       //    Buy
extern int    TS_StepSell      = 3;       //    Sell
       bool   TSProfitOnly     = True;    //     
//+----------------------------------------------------------------------------+

extern string _P5="-    % -";
extern double PercentProfit    = 100.00;  //  
extern double PercentLoss      = 100.00;  //  
       bool   DeleteOrders     = False;   //            
//+----------------------------------------------------------------------------+

extern string _P6="-    -";
extern bool   ExpertTime       = True;    //      
extern string TradeDay         = "1,2,3,4,5"; //    1 = , 5 = . 
extern int    StartHour        = 0;       //     
extern int    StopsHour        = 23;      //    
extern int    Ea.Start         = 0;       //  c 
extern int    Ea.Stop          = 24;      //  c 
//+----------------------------------------------------------------------------+

       string _P7="-   -";
       bool   UseSound         = True;    //   
       string NameFileSound    = "expert.wav"; //   
       int    PauseAfter       = 75;      //     
       int    NumberOfTry      = 3;       //    
       int    Slippage         = 3;       //  
       color  clOpenBuy        = Blue;    //    Buy
       color  clOpenSell       = Red;     //    Sell
       color  clDelete         = Yellow;  //   
       bool   gbNoInit         = False;   //   
       bool   gbDisabled       = False;   //    
//-------    -----------------------------------------+

#include <stdlib.mqh> 
#include <stderror.mqh>      
//+----------------------------------------------------------------------------+

int nor=1;       //   4-5 
string rtm;      //   
double sl, tp;   //   
datetime g_time; 
//+----------------------------------------------------------------------------+
//|                                                                            |
//+----------------------------------------------------------------------------+
int init() {
//----
  int nd=MarketInfo(Symbol(), MODE_DIGITS);
  //+--------------------------------------------------------------------------+
  //----   4-5   
  if (nd>4) nor=10; else nor=1;
//+----------------------------------------------------------------------------+
  gbNoInit=False;
  if (!IsTradeAllowed()) {
    Message("    \n"+
            "  ");
    gbNoInit=True; return;
  }
  if (!IsLibrariesAllowed()) {
    Message("    \n"+
            "    ");
    gbNoInit=True; return;
  }
  if (!IsTesting()) {
    if (IsExpertEnabled()) 
    Message("    ");
    else                  
    Message("  \"  \"");
  }
  return(0);     
}

//+----------------------------------------------------------------------------+
//|                                                                            |>
//+----------------------------------------------------------------------------+
void deinit() {
//----
  if (!IsTesting())
  Comment("");         //     - 
  ObjectDelete("0");   //     - 
  ObjectDelete("1");   //     -  
  return(0);     
}

//+----------------------------------------------------------------------------+
//| !                                                                  |>
//+----------------------------------------------------------------------------+
int start() {
//----
  if (gbDisabled) {
    Message(" !  !"); return;
  }
  if (gbNoInit) {
    Message("   !"); return;
  }
//======================== start()==========================================  
  int  Signal;
  int Count_b,Count_s;
  int Count_0=Count_b+Count_s;
  double AccBal=AccountBalance();
  double AccEqu=AccountEquity(); 
  double pp=MarketInfo(Symbol(), MODE_POINT); //   Point
  double pBid=MarketInfo(Symbol(), MODE_BID); //    Bid
  double pAsk=MarketInfo(Symbol(), MODE_ASK); //    Ask 
  //+--------------------------------------------------------------------------+ 
  //----        
  if (Tradetime(ExpertTime, Ea.Start, Ea.Stop)==1 ) { 
    //+------------------------------------------------------------------------+
    //----          
    if (LP!=0) BezU(Symbol(), -1, Magic); 
    if (LP_Step!=0) BezU(Symbol(), -1, Magic); 
    //+------------------------------------------------------------------------+
    //----     
    if (On_Off_TR) Trailing(Symbol(), -1, Magic);  
    //+------------------------------------------------------------------------+
    //----       %         
    if (AccEqu>=AccBal*(1+PercentProfit/100) || AccEqu<=AccBal*(1-PercentLoss/100)) {
      //+----------------------------------------------------------------------+
      //----     ,  
      ClosePosFirstProfit(Symbol(), -1, Magic);
      //+----------------------------------------------------------------------+
      //----  ,   
      DeleteOrders(Symbol(), -1, Magic);
    }
    //+------------------------------------------------------------------------+ 
    //----        signal_one()  
    Signal=signal_one();
    //+------------------------------------------------------------------------+
    //----           
    if (ReverseSignal) {
      if (Signal==1)Signal=2;
      else 
      if (Signal==2)Signal=1;
    } 
    //+------------------------------------------------------------------------+
    //----  , ,  
    rtm=(infa_0());
    //+------------------------------------------------------------------------+
    //---- ,   
    if (Time[0]==g_time) return (0);
    //==========================================================================
    //    Buy:
    if (Signal==1) {
    //+------------------------------------------------------------------------+
      //----  StopLoss
      if (StopLoss!=0)sl=pBid-StopLoss*pp*nor; else sl=0;
      //+----------------------------------------------------------------------+
      //----  TakeProfit
      if (TakeProfit!=0)tp=pAsk+TakeProfit*pp*nor; else tp=0;
      //+----------------------------------------------------------------------+ 
      //----  ,    
      if (ClosePosifChange)ClosePositions(Symbol(), OP_SELL, Magic);
      //+----------------------------------------------------------------------+ 
      //----      Buy   
      if (!OpenBuy) return (1);
      //+----------------------------------------------------------------------+
      //----     Buy
      if ((Count_0(Magic)<MaxOrdersCount || MaxOrdersCount==-1)) {
        if (Count_b(Magic)<MaxBuyCount || MaxBuyCount==-1) {      
          //+------------------------------------------------------------------+
          //----    Buy
          OpenPosition(Symbol(), OP_BUY, GetSizeLot(), sl, tp, Magic);
          g_time=Time[0];
        }
      }
    }  
    //==========================================================================
    //    Sell:
    if (Signal==2) {
      //+----------------------------------------------------------------------+
      //----  StopLoss
      if (StopLoss!=0)sl=pAsk+StopLoss*pp*nor; else sl=0;
      //+----------------------------------------------------------------------+
      //----  TakeProfit
      if (TakeProfit!=0)tp=pBid-TakeProfit*pp*nor; else tp=0;
      //+----------------------------------------------------------------------+
      //----  ,    
      if (ClosePosifChange)ClosePositions(Symbol(), OP_BUY, Magic);
      //+----------------------------------------------------------------------+
      //----      Sell   
      if (!OpenSell) return (1);
      //+----------------------------------------------------------------------+ 
      //----     Sell
      if ((Count_0(Magic)<MaxOrdersCount || MaxOrdersCount==-1)) {
        if (Count_s(Magic)<MaxSellCount || MaxSellCount==-1) {     
          //+------------------------------------------------------------------+
          //----    Sell
          OpenPosition(Symbol(), OP_SELL, GetSizeLot(), sl, tp, Magic);
          g_time=Time[0];  
        }
      }           
    }
   //+-------------------------------------------------------------------------+
   
   
   //+-------------------------------------------------------------------------+  
  } 
}

//+----------------------------------------------------------------------------+
//|                                                     |>
//+----------------------------------------------------------------------------+
int signal_one() {
//----
  int Signal;
  //+--------------------------------------------------------------------------+
  //----     
  double iao_0  =iAO     (NULL, 0, 0);
  double iac_0  =iAC     (NULL, 0, 0);   
  double imacd_0=iMACD   (NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_MAIN, 0);  
  //+--------------------------------------------------------------------------+
  //----      Buy
  if(iac_0<(-iac_dist) && imacd_0<(-imacd_dist) && iao_0<(-iac_dist))
  //+--------------------------------------------------------------------------+
  //----    ,      Buy 
  Signal=1;
  //+--------------------------------------------------------------------------+ 
  //----      Sell      
  if(iac_0>iac_dist && imacd_0>imacd_dist && iao_0>iac_dist) 
  //+--------------------------------------------------------------------------+
  //----    ,      Sell   
  Signal=2;
  //+--------------------------------------------------------------------------+
  //----          
  HideTestIndicators (true); 
  //+--------------------------------------------------------------------------+
  //----   ,    , Buy  Sell         
  return (Signal);       
}

//+----------------------------------------------------------------------------+
//|    %                                          |>
//+----------------------------------------------------------------------------+
double GetSizeLot(double Loss=1000.0 ) {
//----   
  double Free=AccountFreeMargin(); //    
  double Lot_Val=MarketInfo(Symbol(), MODE_TICKVALUE); //    
  double Min_Lot=MarketInfo(Symbol(), MODE_MINLOT);    //   
  double Max_Lot=MarketInfo(Symbol(), MODE_MAXLOT);    //   
  double Step=MarketInfo(Symbol(), MODE_LOTSTEP);      //    
  double Lot=MathFloor((Free*Risk/100.0)/(Loss*Lot_Val)/Step)*Step; 
  //----
  Print("   = " + DoubleToStr(Free, 1));
  Print("   = " + DoubleToStr(Max_Lot, 1)); // DoubleToStr(Max_Lot,1)  
  Print("   = " + DoubleToStr(Min_Lot, 2)); //     
  Print("   = " + DoubleToStr(Lot, 2));
  
  if (!Dynamic_Lot)Lot=Ficsir_Lot;
  if (Lot<Min_lot)Lot=Min_lot; 
  if (Lot>Max_lot)Lot=Max_lot;
  return (Lot);   
}

//+----------------------------------------------------------------------------+
//|   :      .    : 21.03.2008 |>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
int OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=-1) {
//----
  color clOpen;
  datetime ot;
  double pp, pa, pb;
  int dg, er, it, ticket=0;
  string lsComm=WindowExpertName()+" "+GetNameTF(Period());
  //----
  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage*nor, sl, tp, lsComm, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } 
    else {
      er=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //----    
      Print("Error(",er,") opening position: ",ErrorDescription(er),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //----   
      if (er==2 || er==64 || er==65 || er==133) {
        gbDisabled=True; break;
      }
      //----  
      if (er==4 || er==131 || er==132) {
        Sleep(1000*300); break;
      }
      if (er==128 || er==142 || er==143) {
        Sleep(1000*66.666);
        if (ExistOrders(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
      }
      if (er==140 || er==148 || er==4110 || er==4111) break;
      if (er==141) Sleep(1000*100);
      if (er==145) Sleep(1000*17);
      if (er==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (er!=135) Sleep(1000*7.7);
    }
  }
  return (ticket);
}

//+----------------------------------------------------------------------------+
//|  ,                                                          |>
//+----------------------------------------------------------------------------+
int Tradetime(bool exptime, int OpenHour, int CloseHour) {
//----
  int day[], i=0, np, Trading=0; 
  string st, tmp=TradeDay;
  //----
  ArrayResize(day, 0);
  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ",");
    if (np<0) {
      st=tmp;
      tmp="";
    }
    else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(day, i);
    day[i-1] = StrToInteger(st);
  }
  // --- // if(Minute()<=15  
  int TradingTime=0;
  for (int f=0; f<7; f++) {
    if (DayOfWeek()==day[f]) Trading=1;
  }
  if (OpenHour>CloseHour) {
    if (Hour()<=CloseHour || Hour()>=OpenHour) TradingTime=1;
  }
  if (OpenHour<CloseHour) {
    if (Hour()>=OpenHour && Hour()<=CloseHour) TradingTime=1;
  }
  if (OpenHour==CloseHour) {
    if (Hour()==OpenHour) TradingTime=1;
  }
  if (DayOfWeek()==1 && Hour()<StartHour) TradingTime=0;
  if (DayOfWeek()==5 && Hour()>=StopsHour) TradingTime=0; 
  if (Trading!=1) TradingTime=0;
  if (exptime!=true) TradingTime=1;
  return (TradingTime);  
}

//+----------------------------------------------------------------------------+
//|   :                 : 23.04.2009 |>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -  ("" -  ,NULL -  )  |
//|    op -                 (-1   -  )                     |
//|    mn - MagicNumber             (-1   -  )                       |
//+----------------------------------------------------------------------------+
void BezU(string sy="", int op=-1, int mn=-1) {
//----
  double po, pp;
  int i, k=OrdersTotal();   
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          po=MarketInfo(OrderSymbol(), MODE_POINT);
      
          if (OrderType()==OP_BUY) {
            if (OrderStopLoss()-OrderOpenPrice()<LP_Step*po*nor) {
              pp=MarketInfo(OrderSymbol(), MODE_BID);
              if (pp-OrderOpenPrice()>LP*po*nor) {
                ModifyOrder(-1, OrderOpenPrice()+LP_Step*po*nor, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            if (OrderStopLoss()==0 || OrderOpenPrice()-OrderStopLoss()<LP_Step*po*nor) {
              pp=MarketInfo(OrderSymbol(), MODE_ASK);
              if (OrderOpenPrice()-pp>LP*po*nor) {
                ModifyOrder(-1, OrderOpenPrice()-LP_Step*po*nor, -1);
              }
            }
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|  :             : 11.09.2008 |>
//+----------------------------------------------------------------------------+
//| :                                                                 |
//|    sy -  ("" -  ,NULL -  )  |
//|    op -                 (-1   -  )                     |
//|    mn - MagicNumber             (-1   -  )                       |
//+----------------------------------------------------------------------------+
void Trailing(string sy="", int op=-1, int mn=-1) {
//----
  int i, k=OrdersTotal();
  double po, pp;
  //+--------------------------------------------------------------------------+
  //----        
  if (On_Off_TR)
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        po=MarketInfo(OrderSymbol(), MODE_POINT);
        if (mn<0 || OrderMagicNumber()==mn) {
         
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(OrderSymbol(), MODE_BID);
            if (!TSProfitOnly || pp-OrderOpenPrice()>TS_Buy*po*nor) {
              if (OrderStopLoss()<pp-(TS_Buy+TS_StepBuy-1)*po*nor) {
                ModifyOrder(-1, pp-TS_Buy*po*nor, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(OrderSymbol(), MODE_ASK);
            if (!TSProfitOnly || OrderOpenPrice()-pp>TS_Sell*po*nor) {
              if (OrderStopLoss()>pp+(TS_Sell+TS_StepSell-1)*po*nor || OrderStopLoss()==0) {
                ModifyOrder(-1, pp+TS_Sell*po*nor, -1);
              }
            }
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|   :      28.11.2006 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                               |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
//----
  bool fm;
  double op, pa, pb, os, ot;
  int dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
  int er, it;
  //---- 
  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
 
  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      }
      else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print(" ModifyOrder # " + error(er));
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|   :           : 12.03.2008 |>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -   ("" -  , NULL -  )|
//|    op -                    (-1 -  )                      |
//|    mn - MagicNumber                (-1 -  )                      |
//|    ot -               ( 0 -   )            |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;
 
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return (True);
          }
        }
      }
    }
  }
  return (False);
}

//+----------------------------------------------------------------------------+
//|   :                : 19.02.2008 |>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -   ("" -  , NULL -  )|
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void ClosePositions(string sy="", int op=-1, int mn=-1) {
//----
  int i, k=OrdersTotal();
  //----
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|   :                              : 28.11.2006 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -   ("" -  , NULL -  )|
//|    op -                  (-1 -  )                        |
//|    mn - MagicNumber              (-1 -  )                        |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sy="", int op=-1, int mn=-1) {
//----
  bool fd;
  int er=GetLastError();
  int i, it, ot, k=OrdersTotal();
  //----
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            for (it=1; it<=NumberOfTry; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), clDelete);
              if (fd) {
                if (UseSound) PlaySound(NameFileSound); break;
              }
              else {
                Print("Error(",er,") delete order ",GetNameOP(ot),": ",
                error(er),", try ",it);
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|   :        19.02.2008|>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -   ("" -  , NULL -  )|
//|    op -                  (-1   -  )                    |
//|    mn - MagicNumber              (-1   -  )                      |
//+----------------------------------------------------------------------------+
void ClosePosFirstProfit(string sy="", int op=-1, int mn=-1) {
//----
  int i, k=OrdersTotal();
  if (sy=="0") sy=Symbol();
  //----    
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (OrderProfit()+OrderSwap()>0) ClosePosBySelect();
          }
        }
      }
    }
  }
  //----   
  k=OrdersTotal();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                 |>
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
//----
  bool fc;
  color clClose;
  double ll, pAsk, pBid, pp;
  int er=GetLastError(), it;
  int mn=OrderMagicNumber();
  //----
  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pAsk=MarketInfo(OrderSymbol(), MODE_ASK);
      pBid=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pBid; clClose=clOpenBuy;
      }
      else {
        pp=pAsk; clClose=clOpenSell;
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, pp, Slippage*nor, clClose);
      if (fc) {
        if (UseSound) PlaySound(NameFileSound); break;
      }
      else {
        if (er==146) while (IsTradeContextBusy()) Sleep(1000*PauseAfter);
        Print("Error(",er,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(er),", try ",it);
        Print(OrderTicket(),"  Ask=",pAsk,"  Bid=",pBid,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",mn);
        Sleep(1000*PauseAfter);
      }
    }
  } else Print("  . Close ",GetNameOP(OrderType()));
}

//+----------------------------------------------------------------------------+
//|   :    .   : 01.09.2005|>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
//----
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|                                            |>
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
//-----
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:		    
    return("UnknownPeriod");
  }
}

//+----------------------------------------------------------------------------+
//|   :               : 01.09.2005 |>
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|     m -                                                      |
//+----------------------------------------------------------------------------+
void Message(string m) {
//----
  int d_time;
  //----   
  if(Log) {
    d_time=iTime(NULL, 0, 0);
    Comment(m);
    if (StringLen(m)>0) 
    Print(m);
  }
}

//+----------------------------------------------------------------------------+
//|                                                                |>
//+----------------------------------------------------------------------------+
string error(int eer) {
//----
  string er;
  switch(eer) {
  //---- 
    case 0:
    case 1:   er=" ,   ";                         break;
    case 2:   er=" ";                                                break;
    case 3:   er=" ";                                      break;
    case 4:   er="  ";                                       break;
    case 5:   er="   ";                         break;
    case 6:   er="    ";                               break;
    case 7:   er=" ";                                           break;
    case 8:   er="  ";                                      break;
    case 9:   er="    ";   break;
    case 64:  er=" ";                                           break;
    case 65:  er="  ";                                    break;
    case 128: er="    ";                       break;
    case 129: er=" ";                                           break;
    case 130: er=" ";                                          break;
    case 131: er=" ";                                          break;
    case 132: er=" ";                                                break;
    case 133: er=" ";                                          break;
    case 134: er="    ";                  break;
    case 135: er=" ";                                             break;
    case 136: er=" ";                                                     break;
    case 137: er=" ";                                                break;
    case 138: er="  - ";                                         break;
    case 139: er="    ";                     break;
    case 140: er="  ";                                    break;
    case 141: er="  ";                                      break;
    case 145: er=" ,       "; break;
    case 146: er="  ";                                  break;
    case 147: er="     ";      break;
    case 148: er="       ";  break;
//---- 
    case 4000: er=" ";                                                 break;
    case 4001: er="  ";                             break;
    case 4002: er="  -  ";                             break;
    case 4003: er="    ";                               break;
    case 4004: er="    ";               break;
    case 4005: er="      ";                break;
    case 4006: er="    ";                        break;
    case 4007: er="    ";                            break;
    case 4008: er=" ";                                break;
    case 4009: er="   ";                      break;
    case 4010: er="    ";                          break;
    case 4011: er="  ";                                     break;
    case 4012: er="    ";                                 break;
    case 4013: er="  ";                                            break;
    case 4014: er=" ";                                        break;
    case 4015: er=" ";                                       break;
    case 4016: er=" ";                                break;
    case 4017: er=" DLL  ";                                    break;
    case 4018: er="  ";                            break;
    case 4019: er="  ";                                 break;
    case 4020: er="e     ";          break;
    case 4021: er="   ,   ";    break;
    case 4022: er=" ";                                             break;
    case 4050: er="   ";                 break;
    case 4051: er="   ";                    break;
    case 4052: er="   ";                        break;
    case 4053: er=" ";                                             break;
    case 4054: er="  -";               break;
    case 4055: er="  ";                        break;
    case 4056: er=" ";                                       break;
    case 4057: er="   ";                    break;
    case 4058: er="   ";                        break;
    case 4059: er="     ";                     break;
    case 4060: er="  ";                                    break;
    case 4061: er="  ";                                      break;
    case 4062: er="   string";                             break;
    case 4063: er="   integer";                            break;
    case 4064: er="   double";                             break;
    case 4065: er="    ";                      break;
    case 4066: er="     ";     break;
    case 4067: er="    ";                    break;
    case 4099: er=" ";                                                break;
    case 4100: er="    ";                                 break;
    case 4101: er="  ";                                     break;
    case 4102: er="   ";                              break;
    case 4103: er="  ";                                    break;
    case 4104: er="    ";                        break;
    case 4105: er="    ";                                    break;
    case 4106: er=" ";                                         break;
    case 4107: er="     ";            break;
    case 4108: er="  ";                                      break;
    case 4109: er="  ";                                      break;
    case 4110: er="   ";                               break;
    case 4111: er="   ";                              break;
    case 4200: er="  ";                                      break;
    case 4201: er="   ";                     break;
    case 4202: er="  ";                                       break;
    case 4203: er="  ";                                    break;
    case 4204: er="  ";                                          break;
    case 4205: er="  ";                                   break;
    case 4206: er="   ";                               break;
    case 4207: er="    ";                               break;
    default:   er="unknown error";
  }
  return(er); 
}
//+----------------------------------------------------------------------------+
/*  
  int er = GetLastError();
  error(er);
--------------------   
int er;
  er=GetLastError();
  Print("" + error(er));   
*/ 
//+----------------------------------------------------------------------------+  
//|  : ,                                            |>
//+----------------------------------------------------------------------------+               
string infa_0() {
//---   ,       
  ObjectCreate ("0", OBJ_LABEL, 0, 0, 0); 
  ObjectSetText("0", ": " + DoubleToStr(AccountBalance(), 2), 10,
                     "Times New Roman", Yellow);
  ObjectSet    ("0", OBJPROP_CORNER, 1);
  ObjectSet    ("0", OBJPROP_XDISTANCE, 10);
  ObjectSet    ("0", OBJPROP_YDISTANCE, 20);
  //---   ,      
  ObjectCreate ("1", OBJ_LABEL, 0, 0, 0); 
  ObjectSetText("1", " : " + TimeToStr(TimeCurrent(), TIME_MINUTES), 10, 
                     "Times New Roman", LightGray);
  ObjectSet    ("1", OBJPROP_CORNER, 3);
  ObjectSet    ("1", OBJPROP_XDISTANCE, 10);
  ObjectSet    ("1", OBJPROP_YDISTANCE,  8); 
  return(0);
}

//+----------------------------------------------------------------------------+
//     BUY                              |>
//+----------------------------------------------------------------------------+
int Count_b(int mn) { 
//----
  int BuyCount=0;
  int i, k=OrdersTotal(); 
  
  for (i=0; i<k; i++) {   
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()!=Symbol() || OrderMagicNumber()!=mn) continue;
    if (OrderType()==OP_BUY) BuyCount++; 
  }
  return(BuyCount);
}
//+----------------------------------------------------------------------------+
//     SELL                             |>
//+----------------------------------------------------------------------------+
int Count_s(int mn) { 
//----
  int SellCount=0;
  int i, k=OrdersTotal();
  
  for (i=0; i<k; i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()!=Symbol() || OrderMagicNumber()!=mn) continue;
    if (OrderType()==OP_SELL) SellCount++; 
  }
  return(SellCount);
}
//+----------------------------------------------------------------------------+
//                                      |>
//+----------------------------------------------------------------------------+
int Count_0(int mn) {
//----
  int AllCount=0;
  int i, k=OrdersTotal();
  
  for (i=0; i<k; i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
    if (OrderSymbol()!=Symbol() || OrderMagicNumber()!=mn) continue;
    if ((OrderType()==OP_BUY)||(OrderType()==OP_SELL)) AllCount++;
  }
  return(AllCount);
}




